# ![Scidart logo](https://github.com/scidart/scidart.org/blob/master/img/logo_small.png?raw=true)

**SciDart** is an experimental cross-platform scientific library for Dart.

## 🏹 Goals

The main goal of **SciDart** is run where Dart can run, in other words, run on Flutter, Dart CLI, Dart web, etc.

## 🏃 Motivation

Some time ago I tried make a guitar tuner (frequency estimator) with Flutter, and I faced with the problem: Dart didn't 
have a unified scientific library. 
So, I tried implement something to help me and the community with this problem.

## 🧭 PUB link

Link to the Pub repository: https://pub.dev/packages/scidart

## 🔌 Installation

You can follow instruction in the Pub website: https://pub.dev/packages/scidart#-installing-tab-

## ⚒ Examples

The examples can be found in [the project web site](https://scidart.org/#examples-scidart).

## 🛣 Project milestones

All the project status will be shared and updated in the __Projects__ section of Github.

## 🙌 How to contribute

I recommend check the __Projects__ section and choose a task or choose and solve a problem with **SciDart** and 
implement the missing parts and read the file CONTRIBUTING.md.

The reference values for all functions came from with SciPy. The contributions need use SciPy as reference too.

Every contribution need to have tests, documentation and examples, otherwise, the pull request will be blocked.

## ☕ Supporters

Scidart is an open source project that runs on donations to pay the bills e.g. our domain name. If you want to support Scidart, you can ☕ [**buy a coffee here**](https://www.buymeacoffee.com/polotto).

## ⚠ License

Copyright (c) 2019-present [Angelo Polotto](https://github.com/polotto) and Contributors. Scidart is free and open-source software licensed under the [Apache-2.0 License](./LICENSE). The official logo was created by [Juliano Polotto](https://www.linkedin.com/in/juliano-polotto-550ba379/) and distributed under Creative Commons license (CC BY-SA 4.0 International).