import 'math.dart';

/// physical constants
/// ##
/// Reference:
/// 1. https://physics.nist.gov/cuu/Constants/

/// speed of light in vacuum
const c = 299792458;
const speedOfLight = c;

const mu0 = 4e-7 * pi;

const epsilon0 = 1 / (mu0 * c * c);

/// Planck constant
const h = 6.62607015e-34;
const Planck = h;

const hbar = h / (2 * pi);

/// Newtonian constant of gravitation
const G = 6.67430e-11;
const gravitationalConstant = G;

/// Standard acceleration of gravity
const g = 9.80665;

/// elementary charge
const eC = 1.602176634e-19;
const elementaryCharge = eC;

/// molar gas constant
const R = 8.314462618;
const gasConstant = R;

/// fine-structure constant
const alpha = 7.2973525693e-3;
const fineStructure = alpha;

/// Avogadro constant
const NA = 6.02214076e23;
const Avogadro = NA;

/// Boltzmann constant
const k = 1.380649e23;
const Boltzmann = k;

/// Stefan-Boltzmann constant
const sigma = 5.670374419e-8;
const Stefan_Boltzmann = sigma;

/// Wien wavelength displacement law constant
const Wien = 2.897771955e-3;

/// Rydberg constant
const Rydberg = 10973731.568160;
